int led = 13;

void setup() {
  pinMode(led, OUTPUT); 
  Serial1.begin(9600);
  Serial.begin(115200);
  delay(1000);
  digitalWrite(led, LOW);
}

void loop() {
  char buffer[32];
  char data[2];
  unsigned char id[4];
  int len;
  int seq;
  unsigned short sum;
  int org;
  int gotHeader = 0;
  int nu;
  char checkSum;
  
  digitalWrite(led, HIGH);
  while(!gotHeader) {
    if (Serial1.available() > 0) {
      if (Serial1Data() == 0xA5) {
        gotHeader = Serial1Data() == 0x5A;
      }
      else {
        //Serial.print("Inv.");
        delay(10);
      }
    }
    else {  
      delay(100);
    }
  }
  Serial.print("ok.");
  
  sum = Serial1Data();
  seq = sum >> 5;
  len = sum & 0x1F;
  for(int i = 0; i < len - 1; i++) {
    buffer[i] = Serial1Data();
    sum += buffer[i];
  }
  checkSum = Serial1Data();
  
  Serial.print("len=");
  Serial.print(len, DEC);
  org = buffer[0];
  id[0] = buffer[5];
  id[1] = buffer[6];
  id[2] = buffer[7];
  id[3] = buffer[8];
  nu = (buffer[9] >> 4) & 0x01;
  data[0] = buffer[1] >> 4;
  data[1] = buffer[1] & 0x0F;
  Serial.print("org=");
  Serial.print(org, HEX);
  Serial.print(", id=");
  Serial.print(id[0], HEX);
  Serial.print(id[1], HEX);
  Serial.print(id[2], HEX);
  Serial.print(id[3], HEX);
  Serial.print(", dat=");
  Serial.print(buffer[1], HEX);
  
  Serial.print(", sum=");
  Serial.print(sum, HEX);
  Serial.print(", chk=");
  Serial.print(checkSum, HEX);
  
  if (checkSum == (sum & 0xFF)) {
    //if (org == 5 && id == 0x001A4351 && nu == 0x01) {
    if (org == 5 && nu == 0x01) {
      for (int i = 0; i < 2; i++) {
        switch (data[i]) {
        case 0x01:
          RightSwitchOn();
          break;
        case 0x03:
          RightSwitchOff();
          break;
        case 0x05:
          LeftSwitchOn();
          break;
        case 0x07:
          LeftSwitchOff();
          break;
        } // switch
      } //for
    } //if(org == 5 ...
  } // if (checkSum
  else {
      Serial.print("sum-error.");
  }
}

int Serial1Data(void)
{
  int c;
  while((c = Serial1.read()) == -1) {
    delay(10);
  }
  return c;
}

void RightSwitchOn(void)
{
    for(int i = 0; i < 5; i++) {
      digitalWrite(led, HIGH);
      delay(200);
      digitalWrite(led, LOW);
      delay(200);
    }
}

void RightSwitchOff(void)
{
    for(int i = 0; i < 2; i++) {
      digitalWrite(led, HIGH);
      delay(500);
      digitalWrite(led, LOW);
      delay(500);
    }
}

void LeftSwitchOn(void)
{
    for(int i = 0; i < 10; i++) {
      digitalWrite(led, HIGH);
      delay(100);
      digitalWrite(led, LOW);
      delay(100);
    }
}
void LeftSwitchOff(void)
{
    for(int i = 0; i < 3; i++) {
      digitalWrite(led, HIGH);
      delay(350);
      digitalWrite(led, LOW);
      delay(350);
    }
}



